import java.io.*;


/** Replaces regular expressions, "replaycee", with their counterparts, "replacer".
    See comments in "Usage" below.
*/
public class Filter {

    public static void main(String[] args) {
          
         try { 

               if( args.length < 4 ) {
                   System.err.println("Usage: input_file output_file replacee1 replacer1 ...");
                   System.err.println("       Only US-ASCII set is used reliably.");
                   System.err.println("       Use of characters above FE are not guarateed.");
                   System.exit(1);
               }

                    File inputFile = new File(args[0]);
               FileInputStream fis = new FileInputStream(inputFile);
                   long fileLength = inputFile.length();
                          byte[] b = new byte[(int)fileLength];
             
               fis.read(b);
               //Variant: fis.read(b, 0, fileLength); 
               fis.close();
               fis = null;
               
               //Now, just convert bytes b into string ... Cannot
               //find documentation for this ...
               //String s = new String(b); //Apparently not enough ...

               //Enough for first 127 ... 
               //Apparently not enough for the remaining 128 ...
               String s = new String(b,"US-ASCII"); 
               //US-ASCII = Seven-bit ASCII, a.k.a. ISO646-US, a.k.a. 
               //the Basic Latin block of the Unicode character set

               
               //Note: 
               //Don't understand this:
               //(From http://en.wikipedia.org/wiki/ISO_8859-1):
               //ISO-8859-1 is superset of ISO/IEC 8859-1 and of Windows-1252.

               //Info: ISO 8859-1, formally referred as ISO/IEC 8859-1 or 
               //less formally as Latin-1, is part 1 of ISO/IEC 8859

               //Another possibility is to use ISO-8859-1 
               //which includes characters [80-7E] of "US-ASCII"
               //String s = new String(b,"ISO-8859-1"); 
              

               //System.out.println(s);
               //System.out.println("File " + args[0] + " read successfully ... ");
              
               for( int i=0; i<(args.length-2)/2; i++ ) {
                    s = s.replaceAll(args[2*i + 2],args[2*i + 3]);
               }

               b = s.getBytes("US-ASCII");
               
               FileOutputStream fos = new FileOutputStream(args[1]);
               fos.write(b);
               fos.flush();
               fos.close();
               
               System.exit(0);
         
         } catch ( Throwable e ) {
               System.err.println("Cannot process file ... " + e);
               System.exit(1);
         }     
          
     } //main()

} //class






    /* 
             //Variants:  
         
               BufferedInputStream bis = new BufferedInputStream (
                                         new FileInputStream(args[0])
               );
               int iX = -1;
               byte[] b = new byte[ (new File(args[1]).length ];
               bis.read(b);
    

             //Why we cannot use this:?

         try {
               BufferedReader br = new BufferedReader(new FileReader(args[1]));
               resource[0]= null; //To intiate work. 
               while( (resource[++lineIx] = br.readLine()) != null ) {
                       //GS.con(resource[i]); //debug
               }
               resourceLength = lineIx;
               br.close();
         } catch(IOException ioe) {
             gettingResourceFailed = true;
             log[++logIx] = "Failed to read from URL: " + ioe.getMessage();
         }       



              //Why not this: 
                  File inputFile = new File(args[1]);
                  FileInputStream fis = new FileInputStream(inputFile);
                  while ((c = fis.read()) != -1) {
                  catch (FileNotFoundException e) {
                         System.err.println("FileStreamsTest: " + e);
                  } 
                  catch (IOException e) {
                        System.err.println("FileStreamsTest: " + e);
                  }
   */
